.486
.model flat, stdcall
option casemap: none

PNGBTN	equ	1
; API functions
; ************************************
include	AeroVistaButtons.inc
include lib\bmpbutn.asm
include \masm32\macros\macros.asm
.const
; Resource ids
; ************************************

BORDER_GAP = 2

;---------------------------

IDD_DLG1      equ 101
IDI_ICON      equ 200

IDC_MIN_BTN   equ 400
IDI_MIN_DOWN  equ 401
IDI_MIN_UP    equ 403
IDI_MIN_OVER  equ 402

IDC_MAX_BTN   equ 500
IDI_MAX_DOWN  equ 501
IDI_MAX_UP    equ 503
IDI_MAX_OVER  equ 502

IDC_REST_BTN  equ 600
IDI_REST_DOWN equ 601
IDI_REST_UP   equ 603
IDI_REST_OVER equ 602

IDC_EXIT_BTN  equ 700
IDI_EXIT_DOWN equ 701
IDI_EXIT_UP   equ 703
IDI_EXIT_OVER equ 702

; Required data
; ************************************
.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hWND      dd        ?

hMin      dd        ?
hMax      dd        ?
hRestore  dd        ?
hExit     dd        ?

rct     RECT   <?>

.code

start:


invoke GetModuleHandle, NULL
mov hInstance, eax

invoke LoadIcon, eax, IDI_ICON 
mov hIcon, eax
invoke InitCommonControls
invoke DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, SW_SHOWDEFAULT
invoke ExitProcess, 0


; Dialog procedure
; ************************************

DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL ps:PAINTSTRUCT

    .if uMsg == WM_INITDIALOG
        invoke ImageButton,hWnd,0,0,IDI_MIN_DOWN,IDI_MIN_UP,IDI_MIN_OVER,IDC_MIN_BTN     ;Minimize
        mov hMin,eax
        invoke ImageButton,hWnd,0,0,IDI_MAX_DOWN,IDI_MAX_UP,IDI_MAX_OVER,IDC_MAX_BTN     ;Maximize
        mov hMax,eax
        invoke ImageButton,hWnd,0,0,IDI_REST_DOWN,IDI_REST_UP,IDI_REST_OVER,IDC_REST_BTN ;Restore
        mov hRestore,eax
        invoke IsZoomed,hWnd
        .if eax==0
            mov edx,hRestore
        .else
            mov edx,hMax
        .endif
        invoke ShowWindow,edx,SW_HIDE
        invoke ImageButton,hWnd,0,0,IDI_EXIT_DOWN,IDI_EXIT_UP,IDI_EXIT_OVER,IDC_EXIT_BTN ;Exit
        mov hExit,eax
        invoke SizeBoxes,hWnd

    .elseif  uMsg == WM_COMMAND
        movzx eax,word ptr wParam
        movzx edx,word ptr wParam+2

        .if edx == BN_CLICKED
            .if eax==IDC_MIN_BTN                       ;Minimize  
                invoke ShowWindow,hWnd,SW_MINIMIZE

            .elseif eax==IDC_MAX_BTN                   ;Maximize
                invoke ShowWindow,hMax,SW_HIDE
                invoke ShowWindow,hRestore,SW_SHOW
                invoke ShowWindow,hWnd,SW_MAXIMIZE

            .elseif eax==IDC_REST_BTN                  ;Restore
                invoke ShowWindow,hRestore,SW_HIDE
                invoke ShowWindow,hMax,SW_SHOW
                invoke ShowWindow,hWnd,SW_SHOWNORMAL

            .elseif eax==IDC_EXIT_BTN                  ;Exit Button 
                invoke SendMessage,hWnd,WM_CLOSE,0,0

            .endif
        .endif

    .elseif uMsg == WM_SIZE
        invoke SizeBoxes,hWnd

    .elseif uMsg == WM_LBUTTONDOWN
        invoke SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0 ; Move non client area of window

    .elseif  uMsg == WM_CLOSE 
        invoke EndDialog, hWnd, 0
    .endif
 
    xor eax,eax
    ret

DialogProc endp

; Load Png procedure
; ************************************
LoadPng proc ID:DWORD,pSize:DWORD
local pngInfo:PNGINFO

invoke PNG_Init, addr pngInfo
invoke PNG_LoadResource, addr pngInfo, hInstance, ID
.if !eax
xor eax, eax
jmp @cleanup
.endif
invoke PNG_Decode, addr pngInfo
.if !eax
xor eax, eax
jmp @cleanup
.endif
invoke PNG_CreateBitmap, addr pngInfo, hWND, PNG_OUTF_AUTO, FALSE
.if	!eax
xor eax, eax
jmp @cleanup
.endif
mov edi,pSize
.if edi!=0
lea esi,pngInfo
movsd
movsd
.endif

@cleanup:
push eax	
invoke PNG_Cleanup, addr pngInfo

pop eax
ret

LoadPng endp
; Size Box procedure
; ************************************

SizeBoxes proc uses ebx esi hWnd:HWND

        mov     ebx,hWnd                     ;EBX = hWnd
        sub     esp,sizeof RECT
        invoke  GetClientRect,ebx,esp
        pop     edx                          ;discard RECT.left
        pop     ecx                          ;discard RECT.top
        pop     esi                          ;ESI = RECT.right
        pop     eax                          ;discard RECT.bottom
        sub     esi,BORDER_GAP+43
        invoke  MoveWindow,hExit,esi,BORDER_GAP,43,18,TRUE
        invoke  IsZoomed,ebx
        .if eax==0
            mov edx,hMax
        .else
            mov edx,hRestore
        .endif
        mov     ecx,26
        sub     esi,ecx
        invoke  MoveWindow,edx,esi,BORDER_GAP,ecx,18,TRUE
        mov     ecx,25
        sub     esi,ecx
        invoke  MoveWindow,hMin,esi,BORDER_GAP,ecx,18,TRUE
        ret

SizeBoxes endp

end start